<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: inc/coopBendersSubproblemCW.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_bfccd401955b95cf8c75461437045ac0.html">inc</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">coopBendersSubproblemCW.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="coop_benders_subproblem_c_w_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/**********************************************************************************</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2021 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * This program and the accompanying materials are made available under the</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> **********************************************************************************/</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;gurobi_c++.h&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;cmath&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;numeric&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="exceptions_8hpp.html">exceptions.hpp</a>&quot;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="input_structs_8hpp.html">inputStructs.hpp</a>&quot;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="dyn_array_raii_wrapper_8hpp.html">dynArrayRaiiWrapper.hpp</a>&quot;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>decoop {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html">   34</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html">PlantbusSubproblemCW</a> {</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af48cb65d704614e369696498d709a18e">   35</a></span>&#160;        <span class="keyword">const</span> <a class="code" href="structdecoop_1_1_subproblem_options.html">SubproblemOptions</a> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af48cb65d704614e369696498d709a18e">options_</a>;           </div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab">   36</a></span>&#160;        GRBModel <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab">model_</a>;                            </div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#adbfb3166b1d79902135b0cce8b9b096d">   37</a></span>&#160;        <a class="code" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper&lt;GRBConstr&gt;</a> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#adbfb3166b1d79902135b0cce8b9b096d">equations_</a>;  </div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aecdb6c3ea45c871f69081038fba5aa25">   38</a></span>&#160;        <a class="code" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper&lt;GRBVar&gt;</a> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aecdb6c3ea45c871f69081038fba5aa25">variables_</a>;     </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af0fa8f272e5f8800a7bf532607739d93">   39</a></span>&#160;        <span class="keyword">const</span> std::string <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af0fa8f272e5f8800a7bf532607739d93">coupling_equation_name_</a>;  </div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5fd86f8e5255a5a93ae8a2020909cf0f">   40</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5fd86f8e5255a5a93ae8a2020909cf0f">coupling_equation_</a>;        </div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54">   41</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54">constraints_</a>;              </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9">   42</a></span>&#160;        std::vector&lt;int&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9">model_vars_</a>;               </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad247ed38e4efce149d022550e0478c36">   44</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad247ed38e4efce149d022550e0478c36">num_timesteps_</a>;              </div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad2e244d13adaf901ad358e8f695d29a1">   45</a></span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad2e244d13adaf901ad358e8f695d29a1">pow_sugg_</a>;              </div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5">   46</a></span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5">corepoint_</a>;             </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3ef5a600d1de8f464eed5d37a441f963">   47</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3ef5a600d1de8f464eed5d37a441f963">plant_load_</a>;                   </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a937a25c561ee3be032596ca30c90f4e7">   49</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a937a25c561ee3be032596ca30c90f4e7">rhs_num_records_</a>;       </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae2779d2f3712e01095a5d16b83964942">InitObject</a>();</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aaf7b1f8a23f5b45aa865450477990f68">   57</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aaf7b1f8a23f5b45aa865450477990f68">lambda_index_</a>;                          </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aa3c0b8800ac33bd051f94b56a302183f">PlantbusSubproblemCW</a>(<span class="keyword">const</span> GRBEnv&amp; env, <span class="keyword">const</span> std::string&amp; option_path, <span class="keyword">const</span> <span class="keywordtype">double</span> plant_load, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> num_timesteps);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae71d6b0c1a18c8e31c45235a4a1f6b84">Solve</a>();</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae8279974b7182bbd519f8385924fac33">UpdateCorepoint</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key, <span class="keyword">const</span> <span class="keywordtype">double</span> new_corepoint);</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae8279974b7182bbd519f8385924fac33">UpdateCorepoint</a>(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; new_corepoints);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keywordtype">int</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a06f49aeddff2c1981a3a231c549b8000">GetModelStatus</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a4fcbf5d97b156d8ee4031ea96c0c7af5">GetNewRhs</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a2d5561f12e79233e48339c1c2bac1caf">GetCurrLhs</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#aa890c1d64806136f001992e4eaffb703">GetNewCoeff</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ab500692dcfb4bdb1c3fc11907356cb0f">GetNewCoeffs</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5e02745359b70d8f9f65d14bf6926244">GetSubproblemObjective</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a7a478d2508e1a163bca9baf99db8539d">GenerateAndVerifyCut</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a447b774cba6493024db2f58dd7258907">get_plant_load</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae9afee3d671f727efb530ff3772d2b77">ComputeFeasDistance</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af3205ee08bd2a494b33820d612b7b5ba">ComputeFeasSol</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        </div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#af3205ee08bd2a494b33820d612b7b5ba">ComputeFeasSol</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        std::vector&lt;double&gt; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3f42075cda7f69096355045d648c4599">get_pow_sugg</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordtype">double</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3f42075cda7f69096355045d648c4599">get_pow_sugg</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> i) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        </div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#afbf4b8dc57126920f32ad67adb84af8e">set_pow_sugg</a>(<span class="keyword">const</span> std::vector&lt;double&gt;&amp; in);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#afbf4b8dc57126920f32ad67adb84af8e">set_pow_sugg</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> key, <span class="keyword">const</span> <span class="keywordtype">double</span> val);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        GRBModel&amp; <a class="code" href="classdecoop_1_1_plantbus_subproblem_c_w.html#a64c81ab64caab70f9c6aff7f5bb64a3b">GetModel</a>();</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    };</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;} <span class="comment">//namespace decoop</span></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ae71d6b0c1a18c8e31c45235a4a1f6b84"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae71d6b0c1a18c8e31c45235a4a1f6b84">decoop::PlantbusSubproblemCW::Solve</a></div><div class="ttdeci">void Solve()</div><div class="ttdoc">Solves the subproblem with the currently held power profile suggestion and corepoint. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:54</div></div>
<div class="ttc" id="dyn_array_raii_wrapper_8hpp_html"><div class="ttname"><a href="dyn_array_raii_wrapper_8hpp.html">dynArrayRaiiWrapper.hpp</a></div><div class="ttdoc">Header file for DynArrayRAIIWrapper class. </div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_aac4daea3f91b964dd81e2b80ec15cde9"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#aac4daea3f91b964dd81e2b80ec15cde9">decoop::PlantbusSubproblemCW::model_vars_</a></div><div class="ttdeci">std::vector&lt; int &gt; model_vars_</div><div class="ttdoc">Indices of all entries in variables_ that are part of the plant model. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:42</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ab500692dcfb4bdb1c3fc11907356cb0f"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ab500692dcfb4bdb1c3fc11907356cb0f">decoop::PlantbusSubproblemCW::GetNewCoeffs</a></div><div class="ttdeci">std::vector&lt; double &gt; GetNewCoeffs() const </div><div class="ttdoc">Computes all coefficients of the left hand side of the cut. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:142</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a91f5690237483f342b41e361b6d46cd5"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a91f5690237483f342b41e361b6d46cd5">decoop::PlantbusSubproblemCW::corepoint_</a></div><div class="ttdeci">std::vector&lt; double &gt; corepoint_</div><div class="ttdoc">Corepoint used to generate cuts. Unit is multiples of flexible load. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:46</div></div>
<div class="ttc" id="structdecoop_1_1_subproblem_options_html"><div class="ttname"><a href="structdecoop_1_1_subproblem_options.html">decoop::SubproblemOptions</a></div><div class="ttdoc">Processes user input from file options_subproblem.txt. </div><div class="ttdef"><b>Definition:</b> inputStructs.hpp:95</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a3ef5a600d1de8f464eed5d37a441f963"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3ef5a600d1de8f464eed5d37a441f963">decoop::PlantbusSubproblemCW::plant_load_</a></div><div class="ttdeci">const double plant_load_</div><div class="ttdoc">Flexible load of this subproblem in MW. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:47</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a4fcbf5d97b156d8ee4031ea96c0c7af5"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a4fcbf5d97b156d8ee4031ea96c0c7af5">decoop::PlantbusSubproblemCW::GetNewRhs</a></div><div class="ttdeci">double GetNewRhs() const </div><div class="ttdoc">Computes right hand side of the cut generated from current power profile suggestion. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:89</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_af0fa8f272e5f8800a7bf532607739d93"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#af0fa8f272e5f8800a7bf532607739d93">decoop::PlantbusSubproblemCW::coupling_equation_name_</a></div><div class="ttdeci">const std::string coupling_equation_name_</div><div class="ttdoc">Name of the equation coupling master power suggestion and feasible profile computed in subproblem...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:39</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a06f49aeddff2c1981a3a231c549b8000"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a06f49aeddff2c1981a3a231c549b8000">decoop::PlantbusSubproblemCW::GetModelStatus</a></div><div class="ttdeci">int GetModelStatus() const </div><div class="ttdoc">Returns status code of the model_. See Gurobi reference manual for meaning of codes. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:81</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a5e02745359b70d8f9f65d14bf6926244"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5e02745359b70d8f9f65d14bf6926244">decoop::PlantbusSubproblemCW::GetSubproblemObjective</a></div><div class="ttdeci">double GetSubproblemObjective() const </div><div class="ttdoc">Returns objective value of the model_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:151</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_af3205ee08bd2a494b33820d612b7b5ba"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#af3205ee08bd2a494b33820d612b7b5ba">decoop::PlantbusSubproblemCW::ComputeFeasSol</a></div><div class="ttdeci">std::vector&lt; double &gt; ComputeFeasSol() const </div><div class="ttdoc">Computes the feasible power profile found by the subproblem. Unit is MW. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:177</div></div>
<div class="ttc" id="input_structs_8hpp_html"><div class="ttname"><a href="input_structs_8hpp.html">inputStructs.hpp</a></div><div class="ttdoc">Header file for structs used to process user input from option files. </div></div>
<div class="ttc" id="exceptions_8hpp_html"><div class="ttname"><a href="exceptions_8hpp.html">exceptions.hpp</a></div><div class="ttdoc">Header file for custom exception classes. </div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_adbfb3166b1d79902135b0cce8b9b096d"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#adbfb3166b1d79902135b0cce8b9b096d">decoop::PlantbusSubproblemCW::equations_</a></div><div class="ttdeci">DynArrayRAIIWrapper&lt; GRBConstr &gt; equations_</div><div class="ttdoc">All equations part of the model_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:37</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a5fd86f8e5255a5a93ae8a2020909cf0f"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a5fd86f8e5255a5a93ae8a2020909cf0f">decoop::PlantbusSubproblemCW::coupling_equation_</a></div><div class="ttdeci">std::vector&lt; int &gt; coupling_equation_</div><div class="ttdoc">Indices of the equations in equations_ that represent the coupling equation (1 entry per timestep)...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:40</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ad247ed38e4efce149d022550e0478c36"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad247ed38e4efce149d022550e0478c36">decoop::PlantbusSubproblemCW::num_timesteps_</a></div><div class="ttdeci">const unsigned num_timesteps_</div><div class="ttdoc">Number of timesteps in the model. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:44</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_aa890c1d64806136f001992e4eaffb703"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#aa890c1d64806136f001992e4eaffb703">decoop::PlantbusSubproblemCW::GetNewCoeff</a></div><div class="ttdeci">double GetNewCoeff(const unsigned key) const </div><div class="ttdoc">Computes coefficient of the left hand side of the cut for a given timestep. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:137</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ae2779d2f3712e01095a5d16b83964942"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae2779d2f3712e01095a5d16b83964942">decoop::PlantbusSubproblemCW::InitObject</a></div><div class="ttdeci">unsigned long InitObject()</div><div class="ttdoc">Fills coupling_equation_, constraints_, model_vars_ and lambda_index_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:21</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_aa3c0b8800ac33bd051f94b56a302183f"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#aa3c0b8800ac33bd051f94b56a302183f">decoop::PlantbusSubproblemCW::PlantbusSubproblemCW</a></div><div class="ttdeci">PlantbusSubproblemCW(const GRBEnv &amp;env, const std::string &amp;option_path, const double plant_load, const unsigned num_timesteps)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:44</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_af48cb65d704614e369696498d709a18e"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#af48cb65d704614e369696498d709a18e">decoop::PlantbusSubproblemCW::options_</a></div><div class="ttdeci">const SubproblemOptions options_</div><div class="ttdoc">Holds options specified by user in option file. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:35</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_afbf4b8dc57126920f32ad67adb84af8e"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#afbf4b8dc57126920f32ad67adb84af8e">decoop::PlantbusSubproblemCW::set_pow_sugg</a></div><div class="ttdeci">void set_pow_sugg(const std::vector&lt; double &gt; &amp;in)</div><div class="ttdoc">Sets power profile suggestion. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:203</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a447b774cba6493024db2f58dd7258907"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a447b774cba6493024db2f58dd7258907">decoop::PlantbusSubproblemCW::get_plant_load</a></div><div class="ttdeci">double get_plant_load() const </div><div class="ttdoc">Returns flexible load of this subproblem in MW. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:167</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ad2e244d13adaf901ad358e8f695d29a1"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad2e244d13adaf901ad358e8f695d29a1">decoop::PlantbusSubproblemCW::pow_sugg_</a></div><div class="ttdeci">std::vector&lt; double &gt; pow_sugg_</div><div class="ttdoc">Power profile suggestion. Unit is multiples of flexible load. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:45</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a899358e94d997203250bad1b94e20e54"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a899358e94d997203250bad1b94e20e54">decoop::PlantbusSubproblemCW::constraints_</a></div><div class="ttdeci">std::vector&lt; int &gt; constraints_</div><div class="ttdoc">Indices of all entries in equations_ that are not a coupling equation. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:41</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a64c81ab64caab70f9c6aff7f5bb64a3b"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a64c81ab64caab70f9c6aff7f5bb64a3b">decoop::PlantbusSubproblemCW::GetModel</a></div><div class="ttdeci">GRBModel &amp; GetModel()</div><div class="ttdoc">Returns reference to model_ object. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:207</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ae8279974b7182bbd519f8385924fac33"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae8279974b7182bbd519f8385924fac33">decoop::PlantbusSubproblemCW::UpdateCorepoint</a></div><div class="ttdeci">void UpdateCorepoint(const unsigned key, const double new_corepoint)</div><div class="ttdoc">Update a single entry in the corepoint_ vector. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:73</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_aecdb6c3ea45c871f69081038fba5aa25"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#aecdb6c3ea45c871f69081038fba5aa25">decoop::PlantbusSubproblemCW::variables_</a></div><div class="ttdeci">DynArrayRAIIWrapper&lt; GRBVar &gt; variables_</div><div class="ttdoc">All variables part of the model_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:38</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html">decoop::PlantbusSubproblemCW</a></div><div class="ttdoc">Provides an interface for solving CW subproblems and adding cuts from such problems. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:34</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ae9afee3d671f727efb530ff3772d2b77"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ae9afee3d671f727efb530ff3772d2b77">decoop::PlantbusSubproblemCW::ComputeFeasDistance</a></div><div class="ttdeci">double ComputeFeasDistance() const </div><div class="ttdoc">Computes distance between suggested power profile and the feasible profile found by the subproblem...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:171</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_ad7e12446fa7a1824dd12803d1e6534ab"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#ad7e12446fa7a1824dd12803d1e6534ab">decoop::PlantbusSubproblemCW::model_</a></div><div class="ttdeci">GRBModel model_</div><div class="ttdoc">CW subproblem model. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:36</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a937a25c561ee3be032596ca30c90f4e7"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a937a25c561ee3be032596ca30c90f4e7">decoop::PlantbusSubproblemCW::rhs_num_records_</a></div><div class="ttdeci">const unsigned long rhs_num_records_</div><div class="ttdoc">Number of terms used to compute scalar product on right hand side of a cut. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:49</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a7a478d2508e1a163bca9baf99db8539d"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a7a478d2508e1a163bca9baf99db8539d">decoop::PlantbusSubproblemCW::GenerateAndVerifyCut</a></div><div class="ttdeci">double GenerateAndVerifyCut() const </div><div class="ttdoc">Computes right hand side of the cut and ensures that current power profile suggestion is cut off...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:155</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a2d5561f12e79233e48339c1c2bac1caf"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a2d5561f12e79233e48339c1c2bac1caf">decoop::PlantbusSubproblemCW::GetCurrLhs</a></div><div class="ttdeci">double GetCurrLhs() const </div><div class="ttdoc">Computes value of the left hand side of the generated cut when current power profile suggestion is in...</div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:126</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_aaf7b1f8a23f5b45aa865450477990f68"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#aaf7b1f8a23f5b45aa865450477990f68">decoop::PlantbusSubproblemCW::lambda_index_</a></div><div class="ttdeci">int lambda_index_</div><div class="ttdoc">Index of the objective variable in variables_. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.hpp:57</div></div>
<div class="ttc" id="classdecoop_1_1_plantbus_subproblem_c_w_html_a3f42075cda7f69096355045d648c4599"><div class="ttname"><a href="classdecoop_1_1_plantbus_subproblem_c_w.html#a3f42075cda7f69096355045d648c4599">decoop::PlantbusSubproblemCW::get_pow_sugg</a></div><div class="ttdeci">std::vector&lt; double &gt; get_pow_sugg() const </div><div class="ttdoc">Returns power profile suggestion. Unit is multiples of flexible load. </div><div class="ttdef"><b>Definition:</b> coopBendersSubproblemCW.cpp:191</div></div>
<div class="ttc" id="classdecoop_1_1_dyn_array_r_a_i_i_wrapper_html"><div class="ttname"><a href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper&lt; GRBConstr &gt;</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
